import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Koopa_down here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Koopa_down  extends Enemy
{
    // Das standart Bild vom tten Koopa
    private GreenfootImage koopa_downPic = new GreenfootImage("koopa_down.png");
    // Die Geschwindigkeit mit der sich der tte Koopa bewegt
    private int speed = 5;
    // Variable, die die Richtig angibt in der sich der Goomba bewegt (true = links)
    private boolean direction = true;
    // Gibt an, ob der tote Koopa getreten wrde, wenn ja bewegt er sich
    private boolean kicked;
    
    /**
     * Konstruktor, der dem toten Koopa das richtige Bild gibt
     */
    public Koopa_down()
    {
        kicked = true;
        setImage(koopa_downPic);
    }
    
    public void act() 
    {
        if(active)
        {
            checkFall(koopa_downPic.getHeight());
            getKicked();
            walk();
        }
    }
    
    /**
     * ndert, ob der tote Koopa getreten wurde, beim zweiten Berhren bliebt er wieder stehen
     */
    private void getKicked()
    {
        if(objectAbove(koopa_downPic.getHeight(), Mario.class) && kicked)
        {
            kicked = true;
        }
        else if(objectAbove(koopa_downPic.getHeight(), Mario.class) && !kicked)
        {
            kicked = false;
        }
    }
    
    /**
     * Methode, die den toten Koopa lufen lsst und wenn er gegen eine Wand kommt zum Umdrehen bringt
     */
    public void walk()
    {
        if(kicked)
        {
            if(direction)
            {
                setLocation(getX() - speed , getY());
            }
            else if(!direction)
            {
                setLocation(getX() + speed , getY());
            }
            if(objectToLeft( koopa_downPic.getWidth() ,Ground.class) || objectToLeft( koopa_downPic.getWidth() ,Tunnel.class))
            {
               direction = false;
            }
            if(objectToRight( koopa_downPic.getWidth() ,Ground.class) || objectToRight( koopa_downPic.getWidth() ,Tunnel.class))
            {
                direction = true;
            }
        }
    }
}
