import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;  // Mssen java.util.List bearbeiten knnen fr die Methode getObjects()

/**
 * Write a description of class MarioWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MarioWorld  extends World
{
    // Gibt an welches Level gerade gespielt wird(Leicht = 1, Mittel = 2, Schwer = 3)
    static int level;
    // Variblen zum einfacherer Umgang mit den jeweiligen Objekten
    static Counter counter;
    static Start_button startbutton;
    static Stop_button stopbutton;
    static Restart_button restartbutton;
    static Menu_button menubutton;
    static Next_button nextbutton;
    static Mario mario;
    static Sleep sleep;
    static Pause pause;
    // Das Hintergrundbild fr das laufende Spiel
    private GreenfootImage menuBackground = new GreenfootImage ("menuhintergrund.png");
    // Das Hintergrundbild fr den Menubilschirm
    private GreenfootImage gameBackground = new GreenfootImage ("spielhintergrund.png");

    public MarioWorld()
    {    
        // Erstellt eine 600x400 gre Welt, Objekte knnen sich auch auerhalb der Welt bewegen(false)
        super(600, 400, 1, false);
        // Erstellt das Menu
        createMenu();
        // Stellt ein welche Klassen wie weit im Vordergrund sind
        setPaintOrder(Game_over.class, You_won.class, Menu_button.class, Pause.class, Restart_button.class, Next_button.class,
        Start_button.class, Stop_button.class, DeadGoomba.class, Mario.class, Sleep.class, Ground.class, Tunnel.class, Goomba.class,
        Koopa_down.class, Koopa.class, Star.class);
    }
    
    /**
     * Lscht alle alten Aktre, setzt den richtigen Hintergrund und erstellt das Menu
     */
    public void createMenu()
    {
        removeObjects(getObjects(Actor.class));
        setBackground(menuBackground);
        
        addObject(new Menu_leicht(), 120, 140);
        addObject(new Menu_mittel(), 150, 210);
        addObject(new Menu_schwer(), 180, 280);
    }
    
    /**
     * Erstellt das leichte Level mit allen Objekten
     * Zudem stellt es den richtigen Hintergrund, die Levelvariable ein, lscht alle alten Aktre und
     * erstellt den Sternezhler und den Stopknopf
     */
    public void createWorldEasy()
    {
        level = 1;
        Objects.active = true;
        removeObjects(getObjects(Actor.class));
        setBackground(gameBackground);
        
        counter = new Counter ("Sterne: 0/10");
        addObject(counter, 60, 30);
        
        stopbutton = new Stop_button();
        addObject(stopbutton, 530, 50);
        
        mario = new Mario(counter);
        addObject(mario, 100, 320);
        
        addObject(new Star(), 45, 320);
        addObject(new Star(), 320, 150);
        addObject(new Star(), 560, 320);
        addObject(new Star(), 800, 300);
        addObject(new Star(), 950, 220);
        addObject(new Star(), 1500, 220);
        addObject(new Star(), 1590, 320);
        addObject(new Star(), 1280, 260);
        addObject(new Star(), 1920, 260);
        addObject(new Star(), 2360, 60);
        
        addObject(new Ground(), 125, 250);
        addObject(new Ground(), 400, 330);
        addObject(new Ground(), 540, 350);
        addObject(new Ground(), 640, 330);
        addObject(new Ground(), 800, 330);
        addObject(new Ground(), 1100, 280);
        addObject(new Ground(), 1200, 330);
        addObject(new Ground(), 1240, 310);
        addObject(new Ground(), 1240, 330);
        addObject(new Ground(), 1280, 290);
        addObject(new Ground(), 1280, 310);
        addObject(new Ground(), 1280, 330);
        addObject(new Ground(), 1320, 270);
        addObject(new Ground(), 1320, 290);
        addObject(new Ground(), 1320, 310);
        addObject(new Ground(), 1320, 330);
        addObject(new Ground(), 1360, 330);
        addObject(new Ground(), 1360, 310);
        addObject(new Ground(), 1360, 290);
        addObject(new Ground(), 1360, 270);
        addObject(new Ground(), 1360, 250);
        addObject(new Ground(), 1640, 310);
        addObject(new Ground(), 1640, 330);
        addObject(new Ground(), 580, 350);
        
        addObject(new Goomba(), 380, 330);
        addObject(new Goomba(), 680, 330);
        
        addObject(new Koopa(), 1600, 310);
        
        int anz = 13;
        for(int i = 0; i < anz; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 350);
        }
        
        int anz1 = 5;
        for(int i = 2; i < anz1; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 270);
        }
        addObject(new Ground(), 215, 330);
        
        int anz2 = 10;
        for(int i = 4; i < anz2; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 180);
        }
        
        int anz3 = 47;
        for(int i = 16; i < anz3; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 350);
        }
        
        int anz4 = 27;
        for(int i = 22; i < anz4; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 250);
        }
        
        int anz5 = 41;
        for(int i = 36; i < anz5; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 250);
        }
        
        int anz6 = 51;
        for(int i = 46; i < anz6; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 290);
        }
        
        int anz7 = 53;
        for(int i = 51; i < anz7; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 240);
        }
        
        int anz8 = 55;
        for(int i = 53; i < anz8; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 190);
        }
        
        int anz9 = 57;
        for(int i = 55; i < anz9; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 140);
        }
        
        int anz10 = 65;
        for(int i = 57; i < anz10; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 90);
        }
   
        addObject(new Tunnel(), 2520, 65);
    }
    
    /**
     * Erstellt das mittlere Level mit allen Objekten
     * Zudem stellt es den richtigen Hintergrund, die Levelvariable ein, lscht alle alten Aktre und
     * erstellt den Sternezhler und den Stopknopf
     */
    public void createWorldMid()
    {
        level = 2;
        Objects.active = true;
        removeObjects(getObjects(Actor.class));
        setBackground(gameBackground);
        
        stopbutton = new Stop_button();
        addObject(stopbutton, 530, 50);
        
        counter = new Counter ("Sterne: 0/10");
        addObject(counter, 60, 30);
        
        mario = new Mario(counter);
        addObject(mario, 100, 320);
        
        addObject(new Star(), 140, 280);
        addObject(new Star(), 180, 320);
        addObject(new Star(), 520, 260);
        addObject(new Star(), 920, 220);
        addObject(new Star(), 1280, 250);

        addObject(new Star(), 1680, 180);
        addObject(new Star(), 2100, 300);
        addObject(new Star(), 2100, 170);
        addObject(new Star(), 2450, 110);
        addObject(new Star(), 2450, 300);

        
        addObject(new Ground(), 140, 330);
        addObject(new Ground(), 140, 310);
        addObject(new Ground(), 180, 290);
        addObject(new Ground(), 180, 270);

        addObject(new Ground(), 220, 250);
        addObject(new Ground(), 220, 230);
        addObject(new Ground(), 520, 290);
        addObject(new Ground(), 480, 330);
        addObject(new Ground(), 560, 250);
        addObject(new Ground(), 760, 250);
        addObject(new Ground(), 800, 230);
        addObject(new Ground(), 840, 250);
        addObject(new Ground(), 880, 230);
        addObject(new Ground(), 920, 250);
        addObject(new Ground(), 960, 230);
        addObject(new Ground(), 1800, 260);
        addObject(new Ground(), 1840, 290);
        addObject(new Ground(), 1880, 320);
        addObject(new Ground(), 1880, 340);
        addObject(new Ground(), 2240, 340);
        addObject(new Ground(), 2280, 300);
        addObject(new Ground(), 2450, 210);
        addObject(new Ground(), 2320, 340);
        
        addObject(new Goomba(), 600, 250);
        addObject(new Goomba(), 650, 250);
        addObject(new Goomba(), 840, 230);
        addObject(new Goomba(), 2550, 190);
        addObject(new Goomba(), 2650, 190);
        
        addObject(new Koopa(), 300, 330);
        addObject(new Koopa(), 1920, 320);
        addObject(new Koopa_down(), 2450, 300);
        
        int anz = 13;

        for(int i = 0; i < anz; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 350);
        }
        int anz1= 19;
        for(int i = 15; i < anz1; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 270);
        }
        int anz2= 30;
        for(int i = 25; i < anz2; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 270);
        }
        int anz3= 35;
        for(int i = 30; i < anz3; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 310);
        }
        int anz4= 40;
        for(int i = 35; i < anz4; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 270);
        }
        int anz5= 45;
        for(int i = 40; i < anz5; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 230);
        }
        int anz6= 57;
        for(int i = 47; i < anz6; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 230);
        }
                for(int i = 48; i < anz6; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 360);
        }
        int anz7= 75;
        for(int i = 58; i < anz7; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 360);
        }
        for(int i = 58; i < anz7; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 230);
        }
        
        addObject(new Tunnel(), 2960, 330);
        addObject(new Tunnel(), 2960, 200);
    }
    
    /**
     * Erstellt das schwere Level mit allen Objekten
     * Zudem stellt es den richtigen Hintergrund, die Levelvariable ein, lscht alle alten Aktre und
     * erstellt den Sternezhler und den Stopknopf
     */
    public void createWorldHard()
    {
        level = 3;
        Objects.active = true;
        removeObjects(getObjects(Actor.class));
        setBackground(gameBackground);
        
        counter = new Counter ("Sterne: 0/10");
        addObject(counter, 60, 30);
        
        stopbutton = new Stop_button();
        addObject(stopbutton, 530, 50);
        
        mario = new Mario(counter);
        addObject(mario, 100, 320);
        
        addObject(new Star(), 20, 280);
        addObject(new Star(), 310, 130);
        addObject(new Star(), 700, 320);
        addObject(new Star(), 1260, 320);
        addObject(new Star(), 1370, 140);
        addObject(new Star(), 1580, 320);
        addObject(new Star(), 1900, 320);
        addObject(new Star(), 2170, 180);
        addObject(new Star(), 2490, 180);
        addObject(new Star(), 2800, 320);
                
        addObject(new Ground(), 20, 330);
        addObject(new Ground(), 20, 310);
        addObject(new Ground(), 150, 330);
        addObject(new Ground(), 880, 330);
        addObject(new Ground(), 190, 280);
        addObject(new Ground(), 230, 240);
        addObject(new Ground(), 270, 200);
        addObject(new Ground(), 310, 160);
        addObject(new Ground(), 370, 200);
        addObject(new Ground(), 410, 200);
        addObject(new Ground(), 470, 240);
        addObject(new Ground(), 510, 240);
        addObject(new Ground(), 1080, 330);
        addObject(new Ground(), 1190, 350);
        addObject(new Ground(), 1260, 350);
        addObject(new Ground(), 1330, 350);
        addObject(new Ground(), 1370, 350);
        addObject(new Ground(), 1410, 350);
        addObject(new Ground(), 1370, 290);
        addObject(new Ground(), 1410, 230);
        addObject(new Ground(), 1370, 170);
        addObject(new Ground(), 1410, 110);
        addObject(new Ground(), 1450, 50);
        addObject(new Ground(), 1580, 350);
        addObject(new Ground(), 1640, 350);
        addObject(new Ground(), 1680, 350);
        addObject(new Ground(), 1740, 350);
        addObject(new Ground(), 1800, 350);
        addObject(new Ground(), 1840, 350);
        addObject(new Ground(), 1900, 350);
        addObject(new Ground(), 1920, 350);
        addObject(new Ground(), 1580, 220);
        addObject(new Ground(), 1960, 350);
        addObject(new Ground(), 1990, 330);
        addObject(new Ground(), 2020, 310);
        addObject(new Ground(), 2050, 290);
        addObject(new Ground(), 2080, 270);
        addObject(new Ground(), 2110, 250);
        addObject(new Ground(), 2140, 230);
        addObject(new Ground(), 2170, 210);
        addObject(new Ground(), 2310, 330);
        addObject(new Ground(), 2340, 310);
        addObject(new Ground(), 2370, 290);
        addObject(new Ground(), 2400, 270);
        addObject(new Ground(), 2430, 250);
        addObject(new Ground(), 2460, 230);
        addObject(new Ground(), 2490, 210);
        addObject(new Ground(), 2080, 350);

        addObject(new Ground(), 2080, 330);
        
        addObject(new Goomba(), 240, 330);
        addObject(new Goomba(), 440, 330);
        addObject(new Goomba(), 640, 330);
        addObject(new Goomba(), 840, 330);
        addObject(new Goomba(), 960, 330);
        
        addObject(new Koopa(), 990, 330);
        addObject(new Koopa(), 2160, 330);
        addObject(new Koopa_down(), 2490, 210);

        
        int anz = 29;
        for(int i = 0; i < anz; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 350);
        }
        int anz1 = 40;
        for(int i = 36; i < anz1; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 50);
        }
        int anz2 = 58;
        for(int i = 53; i < anz2; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 350);
        }
        int anz3 = 75;
        for(int i = 64; i < anz3; i++)
        {
            int x = (i) * 40;
            addObject(new Ground(), x, 350);
        }
        addObject(new Tunnel(), 2960, 320);
    }
}
