import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Goomba here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Goomba  extends Enemy
{
    // Das standart Bild vom Goomba
    private GreenfootImage goombaPic = new GreenfootImage("goomba_right.png");
    // Das Goomba Bild nach links
    private GreenfootImage goombaLeft = new GreenfootImage("goomba_left.png");
    // Das Goomba Bild nach rechts
    private GreenfootImage goombaRight = new GreenfootImage("goomba_right.png");
    // Die Geschwindigkeit mit der sich der Goomba bewegt
    private int speed = 2;
    // Variable, die die Richtig angibt in der sich der Goomba bewegt (true = links)
    private boolean direction = true;
    
    /**
     * Konstruktor, der dem Goomba das richtige Bild gibt
     */
    public Goomba()
    {
        setImage(goombaPic);
    }
    
    public void act() 
    {
        if(active)
        {
            checkFall(goombaPic.getHeight());
            walk();
        }
    }
    
    /**
     * Methode, die den Goomba lufen lsst und wenn er gegen eine Wand kommt zum Umdrehen bringt
     */
    public void walk()
    {
        if(getImage() == goombaRight)
        {
            setImage(goombaLeft);
        }
        else
        {
            setImage(goombaRight);
        }
        if(direction)
        {
            setLocation(getX() - speed , getY());
        }
        else if(!direction)
        {
            setLocation(getX() + speed , getY());
        }
        if(objectToLeft( goombaPic.getWidth() ,Ground.class) || objectToLeft( goombaPic.getWidth() ,Tunnel.class))
        {
            direction = false;
        }
        if(objectToRight( goombaPic.getWidth() ,Ground.class) || objectToRight( goombaPic.getWidth() ,Tunnel.class))
        {
            direction = true;
        }
    }
}
