import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Koopa here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Koopa  extends Enemy
{
    // Das standart Koopa Bild
    private GreenfootImage koopaPic = new GreenfootImage("koopa_left.png");
    // Das Goomba Bild nach links 
    private GreenfootImage koopaLeft = new GreenfootImage("koopa_left.png");
    // Das Goomba Bild nach rechts
    private GreenfootImage koopaRight = new GreenfootImage("koopa_right.png");
    // Die Geschwindigkeit mit der sich der Koopa bewegt
    private int speed = 2;
    // Variable, die die Richtig angibt in der sich der Goomba bewegt (true = links)
    private boolean direction = true;
    
    /**
     * Konstruktor, der dem Koopa das richtige Bild gibt
     */
    public Koopa()
    {
        setImage(koopaPic);
    }
    
    public void act() 
    {
        if(active)
        {
            checkFall(koopaPic.getHeight());
            walk();
        }
    }
    
    /**
     * Methode, die den Koopa lufen lsst und wenn er gegen eine Wand kommt zum Umdrehen bringt
     */
    public void walk()
    {
        if(direction)
        {
            setLocation(getX() - speed , getY());
            setImage(koopaLeft);
        }
        else if(!direction)
        {
            setLocation(getX() + speed , getY());
            setImage(koopaRight);
        }
        if(objectToLeft( koopaPic.getWidth() ,Ground.class) || objectToLeft( koopaPic.getWidth() ,Tunnel.class))
        {
            direction = false;
        }
        if(objectToRight( koopaPic.getWidth() ,Ground.class) || objectToRight( koopaPic.getWidth() ,Tunnel.class))
        {
            direction = true;
        }
    }
}
